com.fasterxml.jackson.databind.deser.std

## Class EnumDeserializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<T>
    - - com.fasterxml.jackson.databind.deser.std.StdScalarDeserializer<Object>
      - - com.fasterxml.jackson.databind.deser.std.EnumDeserializer

All Implemented Interfaces:
  ContextualDeserializer, NullValueProvider, ValueInstantiator.Gettable, Serializable

    public class EnumDeserializer
    extends StdScalarDeserializer<Object>
    implements ContextualDeserializer

Deserializer class that can deserialize instances of specified Enum class from Strings and Integers.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`JsonDeserializer.None`

### Field Summary

Fields
`protected Boolean` `_caseInsensitive`
`protected Object[]` `_enumsByIndex`
`protected boolean` `_isFromIntValue` Marker flag for cases where we expect actual integral value for Enum, based on `@JsonValue` (and equivalent) annotated accessor.
`protected CompactStringObjectMap` `_lookupByName`
`protected CompactStringObjectMap` `_lookupByToString` Alternatively, we may need a different lookup object if "use toString" is defined.

### Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

`_valueClass, _valueType, F_MASK_ACCEPT_ARRAYS, F_MASK_INT_COERCIONS`

### Constructor Summary

Constructors
`protected` `EnumDeserializer(EnumDeserializer base, Boolean caseInsensitive)`
`` `EnumDeserializer(EnumResolver byNameResolver)` Deprecated. Since 2.9
`` `EnumDeserializer(EnumResolver byNameResolver, Boolean caseInsensitive)`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
`protected Object` `_deserializeOther(JsonParser p, DeserializationContext ctxt)`
`protected Class<?>` `_enumClass()`
`protected Object` `_fromInteger(JsonParser p, DeserializationContext ctxt, int index)`
`protected Object` `_fromString(JsonParser p, DeserializationContext ctxt, String text)`
`protected CompactStringObjectMap` `_getToStringLookup(DeserializationContext ctxt)`
`JsonDeserializer<?>` `createContextual(DeserializationContext ctxt, BeanProperty property)` Method called to see if a different (or differently configured) deserializer is needed to deserialize values of specified property.
`Object` `deserialize(JsonParser p, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
`static JsonDeserializer<?>` `deserializerForCreator(DeserializationConfig config, Class<?> enumClass, AnnotatedMethod factory)` Deprecated. Since 2.8
`static JsonDeserializer<?>` `deserializerForCreator(DeserializationConfig config, Class<?> enumClass, AnnotatedMethod factory, ValueInstantiator valueInstantiator, SettableBeanProperty[] creatorProps)` Factory method used when Enum instances are to be deserialized using a creator (static factory method)
`static JsonDeserializer<?>` `deserializerForNoArgsCreator(DeserializationConfig config, Class<?> enumClass, AnnotatedMethod factory)` Factory method used when Enum instances are to be deserialized using a zero-/no-args factory method
`Object` `getEmptyValue(DeserializationContext ctxt)` Method called to determine value to be used for "empty" values (most commonly when deserializing from empty JSON Strings).
`boolean` `isCachable()` Because of costs associated with constructing Enum resolvers, let's cache instances by default.
`LogicalType` `logicalType()` Method for accessing logical type of values this deserializer produces.
`EnumDeserializer` `withResolved(Boolean caseInsensitive)`

### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdScalarDeserializer

`deserialize, deserializeWithType, getEmptyAccessPattern, getNullAccessPattern, supportsUpdate`

### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

`_byteOverflow, _checkCoercionFail, _checkDoubleSpecialValue, _checkFloatSpecialValue, _checkFloatToIntCoercion, _checkFromStringCoercion, _checkFromStringCoercion, _checkTextualNull, _coerceBooleanFromInt, _coercedTypeDesc, _coerceEmptyString, _coerceIntegral, _coerceNullToken, _coerceTextualNull, _deserializeFromArray, _deserializeFromEmpty, _deserializeFromEmptyString, _deserializeFromString, _deserializeWrappedValue, _failDoubleToIntCoercion, _findCoercionFromBlankString, _findCoercionFromEmptyArray, _findCoercionFromEmptyString, _findNullProvider, _hasTextualNull, _intOverflow, _isBlank, _isEmptyOrTextualNull, _isFalse, _isIntNumber, _isNaN, _isNegInf, _isPosInf, _isTrue, _neitherNull, _nonNullNumber, _parseBoolean, _parseBooleanFromInt, _parseBooleanPrimitive, _parseBooleanPrimitive, _parseBytePrimitive, _parseDate, _parseDate, _parseDateFromArray, _parseDouble, _parseDoublePrimitive, _parseDoublePrimitive, _parseFloatPrimitive, _parseFloatPrimitive, _parseInteger, _parseInteger, _parseIntPrimitive, _parseIntPrimitive, _parseLong, _parseLong, _parseLongPrimitive, _parseLongPrimitive, _parseShortPrimitive, _parseString, _reportFailedNullCoerce, _shortOverflow, _verifyEndArrayForSingle, _verifyNullForPrimitive, _verifyNullForPrimitiveCoercion, _verifyNullForScalarCoercion, _verifyNumberForScalarCoercion, _verifyStringForScalarCoercion, findContentNullProvider, findContentNullStyle, findConvertingContentDeserializer, findDeserializer, findFormatFeature, findFormatOverrides, findValueNullProvider, getValueClass, getValueInstantiator, getValueType, getValueType, handledType, handleMissingEndArrayForSingle, handleNestedArrayForSingle, handleUnknownProperty, isDefaultDeserializer, isDefaultKeyDeserializer`

### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`deserializeWithType, findBackReference, getAbsentValue, getDelegatee, getEmptyValue, getKnownPropertyNames, getNullValue, getNullValue, getObjectIdReader, replaceDelegatee, unwrappingDeserializer`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### _enumsByIndex

    protected Object[] _enumsByIndex

#### _lookupByName

    protected final CompactStringObjectMap _lookupByName

Since:
  2.7.3

#### _lookupByToString

    protected CompactStringObjectMap _lookupByToString

Alternatively, we may need a different lookup object if "use toString" is defined.

Since:
  2.7.3

#### _caseInsensitive

    protected final Boolean _caseInsensitive

#### _isFromIntValue

    protected final boolean _isFromIntValue

Marker flag for cases where we expect actual integral value for Enum, based on `@JsonValue` (and equivalent) annotated accessor.

Since:
  2.13

### Constructor Detail

#### EnumDeserializer

    public EnumDeserializer(EnumResolver byNameResolver,
                            Boolean caseInsensitive)

Since:
  2.9

#### EnumDeserializer

    protected EnumDeserializer(EnumDeserializer base,
                               Boolean caseInsensitive)

Since:
  2.9

#### EnumDeserializer

    @Deprecated
    public EnumDeserializer(EnumResolver byNameResolver)

Deprecated. Since 2.9

### Method Detail

#### deserializerForCreator

    @Deprecated
    public static JsonDeserializer<?> deserializerForCreator(DeserializationConfig config,
                                                                         Class<?> enumClass,
                                                                         AnnotatedMethod factory)

Deprecated. Since 2.8

#### deserializerForCreator

    public static JsonDeserializer<?> deserializerForCreator(DeserializationConfig config,
                                                             Class<?> enumClass,
                                                             AnnotatedMethod factory,
                                                             ValueInstantiator valueInstantiator,
                                                             SettableBeanProperty[] creatorProps)

Factory method used when Enum instances are to be deserialized using a creator (static factory method)

Returns:
  Deserializer based on given factory method
Since:
  2.8

#### deserializerForNoArgsCreator

    public static JsonDeserializer<?> deserializerForNoArgsCreator(DeserializationConfig config,
                                                                   Class<?> enumClass,
                                                                   AnnotatedMethod factory)

Factory method used when Enum instances are to be deserialized using a zero-/no-args factory method

Returns:
  Deserializer based on given no-args factory method
Since:
  2.8

#### withResolved

    public EnumDeserializer withResolved(Boolean caseInsensitive)

Since:
  2.9

#### createContextual

    public JsonDeserializer<?> createContextual(DeserializationContext ctxt,
                                                BeanProperty property)
                                         throws JsonMappingException

Description copied from interface: `ContextualDeserializer`
Method called to see if a different (or differently configured) deserializer is needed to deserialize values of specified property. Note that instance that this method is called on is typically shared one and as a result method should NOT modify this instance but rather construct and return a new instance. This instance should only be returned as-is, in case it is already suitable for use.

Specified by:
  `createContextual` in interface `ContextualDeserializer`
Parameters:
  `ctxt` - Deserialization context to access configuration, additional deserializers that may be needed by this deserializer
  `property` - Method, field or constructor parameter that represents the property (and is used to assign deserialized value). Should be available; but there may be cases where caller cannot provide it and null is passed instead (in which case impls usually pass 'this' deserializer as is)
Returns:
  Deserializer to use for deserializing values of specified property; may be this instance or a new instance.
Throws:
  `JsonMappingException`

#### isCachable

    public boolean isCachable()

Because of costs associated with constructing Enum resolvers, let's cache instances by default.

Overrides:
  `isCachable` in class `JsonDeserializer<Object>`

#### logicalType

    public LogicalType logicalType()

Description copied from class: `JsonDeserializer`
Method for accessing logical type of values this deserializer produces. Typically used for further configuring handling of values, for example, to find which coercions are legal.

Overrides:
  `logicalType` in class `StdScalarDeserializer<Object>`
Returns:
  Logical type of values this deserializer produces, if known; `null` if not

#### getEmptyValue

    public Object getEmptyValue(DeserializationContext ctxt)
                         throws JsonMappingException

Description copied from class: `JsonDeserializer`
Method called to determine value to be used for "empty" values (most commonly when deserializing from empty JSON Strings). Usually this is same as `JsonDeserializer.getNullValue(com.fasterxml.jackson.databind.DeserializationContext)` (which in turn is usually simply Java null), but it can be overridden for specific types. Or, if type should never be converted from empty String, method can also throw an exception.

This method may be called once, or multiple times, depending on what `JsonDeserializer.getEmptyAccessPattern()` returns.

Default implementation simply calls `JsonDeserializer.getNullValue(com.fasterxml.jackson.databind.DeserializationContext)` and returns value.

Overrides:
  `getEmptyValue` in class `JsonDeserializer<Object>`
Throws:
  `JsonMappingException`

#### deserialize

    public Object deserialize(JsonParser p,
                              DeserializationContext ctxt)
                       throws IOException

Description copied from class: `JsonDeserializer`
Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker or a FIELD_NAME.

The two possible input conditions for structured types result from polymorphism via fields. In the ordinary case, Jackson calls this method when it has encountered an OBJECT_START, and the method implementation must advance to the next token to see the first field name. If the application configures polymorphism via a field, then the object looks like the following.

          {
              "@class": "class name",
              ...
          }

Jackson consumes the two tokens (the `@class` field name and its value) in order to learn the class and select the deserializer. Thus, the stream is pointing to the FIELD_NAME for the first field after the @class. Thus, if you want your method to work correctly both with and without polymorphism, you must begin your method with:

           if (p.currentToken() == JsonToken.START_OBJECT) {
             p.nextToken();
           }

This results in the stream pointing to the field name, so that the two conditions align.

Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

Specified by:
  `deserialize` in class `JsonDeserializer<Object>`
Parameters:
  `p` - Parsed used for reading JSON content
  `ctxt` - Context that can be used to access information about this deserialization activity.
Returns:
  Deserialized value
Throws:
  `IOException`

#### _fromString

    protected Object _fromString(JsonParser p,
                                 DeserializationContext ctxt,
                                 String text)
                          throws IOException

Throws:
  `IOException`

#### _fromInteger

    protected Object _fromInteger(JsonParser p,
                                  DeserializationContext ctxt,
                                  int index)
                           throws IOException

Throws:
  `IOException`

#### _deserializeOther

    protected Object _deserializeOther(JsonParser p,
                                       DeserializationContext ctxt)
                                throws IOException

Throws:
  `IOException`

#### _enumClass

    protected Class<?> _enumClass()

#### _getToStringLookup

    protected CompactStringObjectMap _getToStringLookup(DeserializationContext ctxt)